/**
 * @author vedder
 * @copyright 2008 changeMode design
 */

/**
 * Create new Timer object
 * @param {Object} dad  refernce to parent object or application of which we will be the cild of
 * @return {Object} Timer
 */
function Timer(dad){
	var self = this;
	this.dad = dad;
	this.value = 0;
	this.timerHolder = null; // holds the timerobject reference
	
	this.start = function(){
		if (self.value > 0) {
			if (self.timerHolder === null) {
				self.timerHolder = setInterval(self.increment, 1000, -1);
				$(dad).trigger("timerStartEvent");
			}
		}
	}		
	
	this.stop = function(){
		clearInterval(self.timerHolder)
		self.timerHolder = null;
		$(dad).trigger("timerStopEvent");
	}	
		
	this.clearTimer = function(){
		self.value = 0;
		$(dad).trigger("timerClearEvent");
		$(dad).trigger("timerUpdateEvent",[self.value]);
	}
	
	this.setTimer = function(val){
		self.value = val;
		$(dad).trigger("timerUpdateEvent",[self.value]);
	}
	
	this.increment = function (val){
		self.value += val;
		if(self.value == 0)	$(dad).trigger("timerAlertEvent");
		$(dad).trigger("timerUpdateEvent",[self.value]);
	}
	
	this.isRunning = function (){
		return self.timerHolder !== null;
	}
}

